Subject: Re: Multiple checkouts active for the same repository

From: Gustavo Narea <[email-masked]>
Date: Fri, 24 Sep 2010 12:55:11 +0100

I guess it all comes down to one thing: How can I avoid Git's feature of
making only one branch/checkout active at a time under the same path?

I need to have the branches and their checkouts on different
directories, and it seems like the only way to do it is having one
repository per branch/checkout, which doesn't look like the ideal way of
doing things in Git.

Apart from the situation I describe in the initial email, there's
another limitation in the development environment: Our IDE, Eclipse +
Pydev, assumes each project (i.e., branch/checkout) to be on different
directories and each project should have different settings (e.g., paths
to dependencies, which could be different), but with GIt everything
would be a single project because it's all on the same path.

Thanks in advance.

 - Gustavo.

On 24/09/10 10:29, Gustavo Narea wrote:
> Hello.
> 
> We're currently migrating from another DVCS, which allows us to have
> working copies of each branch in separate directories, so that their
> code can be used simultaneously. However, I haven't found a way to do
> this with Git, at least not an easy way. Can you please help me?
> 
> We are a team of Web developers and testers working on an application.
> There are always a few development branches and a stable branch, and
> testers need all the branches with the very latest code available at all
> times.
> 
> The way we handle it at the moment is very simple because the server
> hosting the remote repository is the same that hosts the deployed
> instances of each branch, so when we push to the remote repository, the
> code for each site is automatically updated.
> 
> We use the following structure:
> /srv/repositories/project/branch1
> /srv/repositories/project/branch2
> /srv/repositories/project/branch3
> 
> Is there any simple way to do this with Git? I can only think of two
> options that involve hooks:
> 
>     * Have a hook that exports each branch to a directory like
>       /srv/repositories/project/branchN
>     * Have one Git repository per branch, so that each repository have a
>       different checkout active. Then the main remote repository will
>       have post-receive hooks that trigger a pull on each individual
> 
> I'm not particularly happy with either way. Is there a better solution?
> 

-- 
Gustavo Narea.
Software Developer.
2degrees, Ltd. <http://dev.2degreesnetwork.com/>.